SystemOrganization addCategory: 'OrbeonPersistenceApi_Tests'!

TestCase subclass: #OrbeonPersistenceRestLayerTest
	instanceVariableNames: 'restClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi_Tests'!

OrbeonPersistenceRestLayerTest subclass: #OrbeonPersistenceRestLayer2016_2_Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonPersistenceApi_Tests'!

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'services' stamp: 'BrunoBB 12/19/2016 09:44'!
orbeonFormSummaryQuery

^
'<search>
    <query/>
    <query control="input" html-label="false" match="substring" name="name" path="section-1[1]/name[1]" search-field="true" summary-field="true" type="xs:string"/>
    <page-size>10</page-size>
    <page-number>1</page-number>
    <lang>en</lang>
</search>'! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'services' stamp: 'BrunoBB 12/19/2016 04:31'!
testDeleteFormDefinition
"	<delete>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>
"
	| result id |

	id := (self getOrbeonApplicationClass getLatestSavedDefinition: 'test-2' app: 'agesic' ifNone: [nil]) ifNotNil: [:def | def id] ifNil: [self assert: false] .

	restClient url: 'http://192.168.29.142:8787/orbeon-gemstone-api/crud/orbeon/builder/data/', id, '/data.xml'.

	result := restClient delete.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'services' stamp: 'BrunoBB 12/19/2016 08:47'!
testDeleteFormInstance
"	<delete>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml'>
"
	| result id |

	id := (self getOrbeonApplicationClass formDefinitionNamed: 'test-2' in: 'agesic') 
				ifNil: [self assert: false] 
				ifNotNil: [:def | (def instances asArray detect: [:inst| inst deleted = 'N'] ifNone: [self assert: false]) id].

	restClient url: 'http://192.168.29.142:8787/orbeon-gemstone-api/crud/agesic/test-2/data/', id, '/data.xml'.

	result := restClient delete.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'other' stamp: 'BrunoBB 12/19/2016 09:42'!
testFormBuilderSummary
"	<post>
	<produces: 'application/xml'>
	<path: '/search/{2}/{1}'>
"! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'services' stamp: 'BrunoBB 12/19/2016 09:45'!
testFormSummary
"	<post>
	<produces: 'application/xml'>
	<path: '/search/{2}/{1}'>
"
	| result |

	restClient 
		entity: ((ZnStringEntity xml: self orbeonFormSummaryQuery) contentType: ZnMimeType applicationXml);
		url: 'http://192.168.29.142:8787/orbeon-gemstone-api/search/agesic/test-2'.

	result := restClient post.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'services' stamp: 'BrunoBB 12/19/2016 03:24'!
testPublishNewForm
"	<put>
	<consumes: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml?document={3}'>
"
	| result id |

	id := (self getOrbeonApplicationClass getLatestSavedDefinition: 'test-2' app: 'agesic' ifNone: [nil]) ifNotNil: [:def | def id] ifNil: [UUID new asString].

	restClient 
		entity: ((ZnStringEntity xml: OrbeonFormDefinitionTemplate form_test_2) contentType: ZnMimeType applicationXml);
		headerAt: 'orbeon-form-definition-version' put: 'next';
		url: 'http://192.168.29.142:8787/orbeon-gemstone-api/crud/agesic/test-2/form/form.xhtml?document=', id.

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'other' stamp: 'BrunoBB 12/18/2016 12:09'!
testRePublishForm! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'services' stamp: 'BrunoBB 12/19/2016 07:46'!
testSaveFormDefinition
"	<put>
	<path: '/crud/orbeon/builder/data/{id}/data.xml/?valid={aBoolean}'>
"
	| result id |

	id := (self getOrbeonApplicationClass getLatestSavedDefinition: 'test-2' app: 'agesic' ifNone: [nil]) ifNotNil: [:def | def id] ifNil: [UUID new asString].

	result := restClient 
					put: 'http://192.168.29.142:8787/orbeon-gemstone-api/crud/orbeon/builder/data/', id, '/data.xml/?valid=true' 
					contents: OrbeonFormDefinitionTemplate form_test_2.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'services' stamp: 'BrunoBB 12/19/2016 07:53'!
testSaveFormInstance
"	<put>
	<produces: 'application/xml'>
	<path: '/crud/{app}/{form-name}/data/{id}/data.xml?valid={true|false}'>
"
	| result id version |

	version := (self getOrbeonApplicationClass getLatestSavedDefinition: 'test-2' app: 'agesic' ifNone: [nil]) ifNotNil: [:def | def version printString] ifNil: ['1'].
	id := UUID new asString.

	restClient 
		headerAt: 'orbeon-form-definition-version' put: version;
		entity: ((ZnStringEntity xml: OrbeonFormInstanceTemplate form_test_2) contentType: ZnMimeType applicationXml);
		url: 'http://192.168.29.142:8787/orbeon-gemstone-api/crud/agesic/test-2/data/', id, '/data.xml?valid=true'.

	result := restClient put.

	self assert: restClient isSuccess.! !

!OrbeonPersistenceRestLayer2016_2_Test methodsFor: 'other' stamp: 'BrunoBB 12/17/2016 11:16'!
testUnpublishForm! !

!OrbeonPersistenceRestLayerTest methodsFor: 'Accessing' stamp: 'BrunoBB 12/17/2016 08:19'!
restClient
	^restClient! !

!OrbeonPersistenceRestLayerTest methodsFor: 'Updating' stamp: 'BrunoBB 12/17/2016 08:19'!
restClient: newValue
	restClient := newValue! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/17/2016 08:19'!
setUp

	super setUp.

	restClient := ZnClient new.! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/17/2016 08:19'!
tearDown

	super tearDown.

	restClient close.! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/17/2016 08:19'!
testServiceBuilderDataID
 "/crud/orbeon/builder/data/{1}/data.xml"
	| result |

	result := restClient get: 'http://192.168.29.142:8787/orbeon-gemstone-api/crud/orbeon/builder/data/31c47749d8149acdbff83f16333d527e9ad21844/data.xml'.


	self assert: true! !

!OrbeonPersistenceRestLayerTest methodsFor: 'other' stamp: 'BrunoBB 12/17/2016 08:19'!
testServiceBuilderDataIDvalid
 "/crud/orbeon/builder/data/{1}/data.xml/?valid={2}"
	| result |

	result := restClient get: 'http://192.168.29.142:8787/orbeon-gemstone-api/crud/orbeon/builder/data/31c47749d8149acdbff83f16333d527e9ad21844/data.xml'.
	restClient request setBody: 'xml definition'.


	self assert: true! !
